*****************************************************************************
*  Program    : RTOS:  68K Real Time OS
*  Module     :	SERVICE.SRC:  RTOS service interface
*  Unit       :	
*  Purpose    : 'C' O.S. SERVICE INTERFACE
*  Host       :	NEC 386/20   MS DOS 3.3   Microtec ASM68K 6.3B 
*  Target     :	RT294/RT292   MC68000   RTOS
*  Packages   : None
*  Author     : Allen Nance
*  Company    :	Refraction Technology, Inc.
*		2626 Lombardy Lane, Suite 105
*		Dallas, Texas  75220
*		(214) 353-0609     Fax (214) 353-9659
*  Copyright  :	(c) 1987,1989 Refraction Technology, Inc.
*  Notes      :	
*
*  Revised    :	
*	14 Nov 89  MBE - Added os_version call
*	14 Dec 87  WAN - initial creation
*	
*  $Revision:   240.0  $
*  $Logfile:   R:/cpu68000/das/os/service.srv  $
*****************************************************************************
*
	XDEF	_TSK_SPAWN,_TSK_ACTIVE,_TSK_DELETE
	XDEF	_TSK_SUSPND,_TSK_RESUME,_TSK_ID
	XDEF	_OS_VERSION
	XDEF	_TSK_RSCHD
	PAGE
	SECTION	code
*	
*	TSK_SPAWN(&TSK_ID,TSK_NAME,STACK_SIZ,HEAP_SIZ);
*		RETURNS:	0 = OK
*				1 = NO SLOT AVAILABLE
*				2 = NO RAM FOR STACK AND HEAP
_TSK_SPAWN
	MOVEM.L	D3/D7/A0,-(SP)		;SAVE REG
	MOVE.L	16+4(SP),D0		;GET PROCESS NAME
	MOVE	16+14(SP),D3		;GET HEAP SIZE
	SWAP	D3			;IN MSW
	MOVE	16+10(SP),D3		;GET STACK SIZE
	MOVEQ.L	#1,D7			;SET OPEN COMMAND
	TRAP	#1			;CALL SERVICE TRAP
	MOVE.L	A0,D3			;SAVE PROCESS ID
	MOVE.L	16+0(SP),A0		;RETURN PROCESS ID
	MOVE.L	D3,(A0)
	MOVE.L	D7,D0			;RETURN ERROR CODE
	MOVEM.L	(SP)+,D3/D7/A0
	RTS
*
*	TSK_ACTIVE(TSK_ID,START_ADR);
*		RETURNS:	0 = OK
*				1 = NO PROCESS THERE
*				2 = PROCESS ID OUT OF RANGE
*				5 = PROCESS ALREADY ACTIVE
_TSK_ACTIVE
	MOVEM.L	D7/A0-A1,-(SP)		;SAVE REG
	MOVE.L	16+0(SP),A0		;GET DEVICE NUMBER
	MOVE.L	16+4(SP),A1		;GET START ADDRESS
	MOVEQ.L	#2,D7			;SET OPEN COMMAND
	TRAP	#1			;CALL SERVICE TRAP
	MOVE.L	D7,D0			;RETURN ERROR CODE
	MOVEM.L	(SP)+,D7/A0-A1
	RTS
	PAGE
*
*	TSK_ID(TSK_ID,&NAME);
*		RETURNS:	0 = OK
*				1 = PROCESS NOT THERE
*				2 = PROCESS ID OUT OF RANGE
_TSK_ID
	MOVEM.L	D7/A0,-(SP)		;SAVE REG
	MOVE.L	12+0(SP),A0		;GET DEVICE NUMBER
	MOVEQ.L	#2,D7			;SET OPEN COMMAND
	TRAP	#1			;CALL SERVICE TRAP
	MOVE.L	12+4(SP),A0		;RETURN PROCESS ID
	MOVE.L	D0,(A0)
	MOVE.L	D7,D0			;RETURN ERROR CODE
	MOVEM.L	(SP)+,D7/A0
	RTS
*
*	TSK_DELETE(TSK_ID);
*		RETURNS:	0 = OK
*				1 = PROCESS NOT THERE
*				2 = PROCESS ID OUT OF RANGE
_TSK_DELETE
	MOVEM.L	D7/A0,-(SP)		;SAVE REG
	MOVE.L	12+0(SP),A0		;GET DEVICE NUMBER
	MOVEQ.L	#4,D7			;SET CLOSE COMMAND
	TRAP	#1			;CALL SERVICE TRAP
	MOVE.L	D7,D0			;RETURN ERROR CODE
	MOVEM.L	(SP)+,D7/A0
	RTS
	PAGE
*
*	TSK_SUSPND(TSK_ID);
*		RETURNS:	0 = OK
*				1 = PROCESS NOT THERE
*				2 = PROCESS ID OUT OF RANGE
*				4 = PROCESS NOT ACTIVE
_TSK_SUSPND
	MOVEM.L	D7/A0,-(SP)		;SAVE REG
	MOVE.L	12+0(SP),A0		;GET DEVICE NUMBER
	MOVEQ.L	#5,D7			;SET READ COMMAND
	TRAP	#1			;CALL SERVICE TRAP
	MOVE.L	D7,D0			;RETURN ERROR CODE
	MOVEM.L	(SP)+,D7/A0
	RTS
*
*	TSK_RESUME(TSK_ID);
*		RETURNS:	0 = OK
*				1 = PROCESS NOT THERE
*				2 = PROCESS ID OUT OF RANGE
*				4 = PROCESS NOT ACTIVE
_TSK_RESUME
	MOVEM.L	D7/A0,-(SP)		;SAVE REG
	MOVE.L	12+0(SP),A0		;GET DEVICE NUMBER
	MOVEQ.L	#6,D7			;SET READ COMMAND
	TRAP	#1			;CALL SERVICE TRAP
	MOVE.L	D7,D0			;RETURN ERROR CODE
	MOVEM.L	(SP)+,D7/A0
	RTS
*
*	TSK_RSCHD();
*	RETURNS NOTHING
_TSK_RSCHD
	TRAP	#0		;O.S. SYSTEM TRAP FOR RESCHEDULE
	RTS
*
*	OS_VERSION();
*	RETURNS VERSION TIMES 100 (i.e. VERSION 1.01 GIVES '101')
_OS_VERSION
	MOVE.L	D7,-(SP)		;SAVE REG
	MOVEQ.L	#0,D7			;SET OS VERSION COMMAND
	TRAP	#1			;CALL SERVICE TRAP
	MOVE.L	D7,D0			;RETURN ERROR CODE
	MOVE.L	(SP)+,D7
	RTS
	END

